# -*- coding: utf-8 -*-

from tkinter import *

def string2Forest(string) :
    ch_tmp = string
    freq = []
    
    while ch_tmp != "" :
        car = ch_tmp[0]
        freq.append([ch_tmp.count(car), car])
        ch_tmp=ch_tmp.replace(car,"")
    freq.sort(key=lambda x: (x[0],x[1]))
    
    return freq
    
def huffmanStep(tree):
    ng = tree.pop(0)
    nd = tree.pop(0)
    f = ng[0]+nd[0]
    
    tree.append([f,ng,nd])
    tree.sort(key=lambda x: (x[0],-len(x)))
    
    return tree

def forest2Htree(forest) :
    
    while len(forest) > 1 :
        forest = huffmanStep(forest)

    return forest[0]

def tree2Code(tree,code="",dico={}) :
    
    if len(tree) == 2 :
        dico[tree[1]] = code
    else:
        tree2Code(tree[1],code + "0", dico)
        tree2Code(tree[2],code + "1", dico)
        
    return dico

def coding(string):
    code = tree2Code(forest2Htree(string2Forest(string)))
    ch_code = ""
    
    for i in string :
        ch_code += str(code[i])
        
    return string, code, ch_code

def display() :
    mess = entry1.get()
    
    if mess!="":
        entry1.delete(0,END)
        result=coding(mess)
        text3["text"] = result[0]
        text5["text"] = result[2]
        text7["text"] = result[1]
 
fen1 = Tk()
fen1.title('coding de Huffman')
text1 = Label(fen1, text="Phrase à compresser :")
entry1 = Entry(fen1)
button1 = Button(fen1, text="OK", command=display)
text2 = Label(fen1, text="Phrase traitée :")
text3 = Label(fen1, text="")
text4 = Label(fen1, text="Phrase compressée :")
text5 = Label(fen1, text="")
text6 = Label(fen1, text="Code de Huffman :")
text7 = Label(fen1, text="")
button2 = Button(fen1, text="Quitter", command=fen1.destroy)

text1.grid(row = 0, column = 0)
entry1.grid(row = 0, column = 1)
button1.grid(row = 0, column = 2)
text2.grid(row = 1, column = 0)
text3.grid(row = 1, column = 1)
text4.grid(row = 2, column = 0)
text5.grid(row = 2, column = 1, columnspan = 2)
text6.grid(row = 3, column = 0)
text7.grid(row = 3, column = 1, columnspan = 2)
button2.grid(columnspan = 3)

fen1.mainloop()
